/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 3200; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 4.072660848668706e-06,4.089566958773627e-06,4.079254728656379e-06,4.083439225963682e-06 };
    static double noise_model_B[] = { 6.330953782542096e-06,2.6814263075946953e-05,2.7640855951176975e-05,1.0850151718582972e-05 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { 3.6336558034294486e-11,4.0138075616024185e-11,4.025210319138356e-11,3.637943492932889e-11 };
    static double noise_model_D[] = { 4.261059142212002e-07,-3.608492726817582e-07,-3.5105783779881635e-07,3.609013552593955e-07 };
    double digital_gain = (sens / 400.0) < 1.0 ? 1.0 : (sens / 400.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
